*-----------------------------------------------------------------
* Money2Str
*
*         
* -----------------------------------------------------------------
* 
*
* yMoney -     (  0.00)
* nRound - ,        (  2)
* IsWord -          (  .F.)
* AllLower -          
*			..   (  .F.)
* -----------------------------------------------------------------
* 
* 
*   ,      Currency  Numeric  
*   Currency    922,337,203,685,477.5807
* ,     ,  ,     
*    . ..     . 
*  ,          (nRound<=0). 
*       .
*
*  IsWord  ,   nRound 1  2. 
*   nRound   1  2,  IsWord - . 
* 
*  ,    ,  FoxPor       18 
* ,       15.  ,   ,   
*       15  ,    16  18 
*   ,    18  .
*
*   ,         
*       . ,  ,  
*      (). ,   - 
*        ( ),    
*   4  .T.

FUNCTION Money2Str
LPARAMETERS yMoney, nRound, IsWord, AllLower
LOCAL lcReturnValue
lcReturnValue = ""
*     
*      ,   15    
IF InList(TYPE("yMoney"),"N","Y")=.F. OR ABS(m.yMoney)>=10**15
	yMoney=0.00
ENDIF
* FoxPro     18 ,       ,
*   15    
IF TYPE("nRound")<>"N" OR Between(m.nRound,-14,18)=.F.
	nRound=2
ENDIF
*  nRound   1  2,    
*  nRound<=0,     .
IF TYPE("IsWord")<>"L" OR Inlist(m.nRound,1,2)=.F.
	IsWord=.F.
ENDIF
*    
IF TYPE("AllLower")<>"L" 
	AllLower=.F.
ENDIF


*  ,     
DIMENSION paHundreds(9), paTens(9), paUnits(19), paDimensions(6,4)

*  ""
paDimensions[1,1]='  '
paDimensions[1,2]='  '
paDimensions[1,3]=' '
paDimensions[1,4]=' '

paDimensions[2,1]='  '
paDimensions[2,2]='  '
paDimensions[2,3]=' '
paDimensions[2,4]=' '

paDimensions[3,1]='  '
paDimensions[3,2]='  '
paDimensions[3,3]=' '
paDimensions[3,4]=' '

paDimensions[4,1]='  '
paDimensions[4,2]='  '
paDimensions[4,3]=' '
paDimensions[4,4]=' '

paDimensions[5,1]='  '
paDimensions[5,2]='  '
paDimensions[5,3]=' '
paDimensions[5,4]=' '

paDimensions[6,1]='  '
paDimensions[6,2]='  '
paDimensions[6,3]=' '
paDimensions[6,4]=' '

*  ""
paUnits[1]=''
paUnits[2]=''
paUnits[3]=' '
paUnits[4]=' '
paUnits[5]=' '
paUnits[6]=' '
paUnits[7]=' '
paUnits[8]=' '
paUnits[9]=' '
paUnits[10]=' '
paUnits[11]=' '
paUnits[12]=' '
paUnits[13]=' '
paUnits[14]=' '
paUnits[15]=' '
paUnits[16]=' '
paUnits[17]=' '
paUnits[18]=' '
paUnits[19]=' '

*  ""
paTens[1]=''
paTens[2]=' '
paTens[3]=' '
paTens[4]=' '
paTens[5]=' '
paTens[6]=' '
paTens[7]=' '
paTens[8]=' '
paTens[9]=' '

*  ""
paHundreds[1]=' '
paHundreds[2]=' '
paHundreds[3]=' '
paHundreds[4]=' '
paHundreds[5]=' '
paHundreds[6]=' '
paHundreds[7]=' '
paHundreds[8]=' '
paHundreds[9]=' '

*  ,     
LOCAL lcMoney
*  STR()     ,   20 
lcMoney=LTRIM(STR(ABS(ROUND(m.yMoney,m.nRound)),20,IIF(m.nRound<0,0,m.nRound)))

*       15    -
*       .
IF AT(SET("POINT"),m.lcMoney)=0
	lcMoney=PADL(m.lcMoney,15)
ELSE
	lcMoney=SPACE(15-AT(SET("POINT"),m.lcMoney)+1)+STRTRAN(m.lcMoney,SET("POINT")," ")
ENDIF

*   
LOCAL lcWordMoney, lnI, lcNumber3, lnHundreds, lnTens, lnUnits
lcWordMoney=''		&&   

*      ,   ""  
*     3   .
FOR lnI=1 TO IIF(m.nRound>0,6,5)
	lnHundreds=Int(VAL(SubStr(m.lcMoney,3*(m.lnI-1)+1,1)))
	lnTens=Int(VAL(SubStr(m.lcMoney,3*(m.lnI-1)+2,1)))
	lnUnits=Int(VAL(SubStr(m.lcMoney,3*(m.lnI-1)+3,1)))
	IF m.lnTens=1
		lnUnits=10+m.lnUnits
	ENDIF
	lcNumber3=''		&& ,    3 
	*  
	IF m.lnHundreds>0
		lcNumber3=m.lcNumber3+paHundreds[m.lnHundreds]
	ENDIF
	*  
	IF m.lnTens>0
		lcNumber3=m.lcNumber3+paTens[m.lnTens]
	ENDIF
	*  
	DO CASE
	CASE m.lnUnits=0
		*        ,     ' '
		IF EMPTY(m.lcNumber3)=.T. AND (m.lnI=5 AND EMPTY(m.lcWordMoney)=.T. OR m.lnI=6)
				lcNumber3=' '
		ENDIF
		*   m.lcNumber3   (..    ) 
		*      ,     
		*   ,    (..     )
		IF EMPTY(m.lcNumber3)=.F. OR InList(m.lnI,5,6)
			lcNumber3=m.lcNumber3+paDimensions[m.lnI,4]
		ENDIF
	CASE InList(m.lnUnits,1,2)
		lcNumber3=m.lcNumber3+paDimensions[m.lnI,m.lnUnits]
	CASE InList(m.lnUnits,3,4)
		lcNumber3=m.lcNumber3+paUnits[m.lnUnits]+paDimensions[m.lnI,3]
	OTHERWISE
		lcNumber3=m.lcNumber3+paUnits[m.lnUnits]+paDimensions[m.lnI,4]
	ENDCASE
	*      ""
	IF m.lnI=6
		DO CASE
		CASE m.nRound>2
			*       , 
			*     , : " 12.3 "
			lcNumber3 = SubStr(m.lcMoney,3*(m.lnI-1)+1,3)+SET("POINT")+;
						SubStr(m.lcMoney,3*(m.lnI-1)+4)+ paDimensions[m.lnI,3]
		CASE m.IsWord=.F.
			*       , 
			*         
			lcNumber3 = SubStr(m.lcMoney,3*(m.lnI-1)+1,3)+;
						SubStr(m.lcNumber3,RAT(' ',m.lcNumber3))
		ENDCASE
	ENDIF
	*      3 
	lcWordMoney = m.lcWordMoney + m.lcNumber3
ENDFOR

*       
m.lcWordMoney = LTRIM(m.lcWordMoney)

*    
IF m.AllLower=.F.
	m.lcWordMoney = UPPER(LEFT(m.lcWordMoney,1))+SubStr(m.lcWordMoney,2)
ENDIF

RETURN(m.lcWordMoney)
